

//FUNCIONES PARA LA BUSQUEDA DE CEROS DE UNA FUNCION de una variable unidimensional

double biseccion(double f(double), double a, double b,
		 double eps, int & n, int & is){
  /*if( f(a)*f(b) > 0 ) { is = -1; return 0; }
    else { is = 0; }*/
  double xm; n = 0;

  if ( f(a)*f(b) <= 0 ){
    is = 0;
    while( abs(b-a) > eps ){
      xm = (a+b)/2; n++;
      if(f(a)*f(xm) < 0){
	b = xm;
      } else if(f(a)*f(xm) > 0){
	a = xm;
      } else{
	return xm;
      }
    }

  }else{
    is = -1;
  }
  return b;
}

double newton(double f(double), double Df(double), double x0,
	      double eps, int & n, int & is){
  is = 0; n=0; double xa, x;
  xa = x0; x = xa - f(xa)/Df(xa); n+=1;
  while( abs(x-xa) > eps){
    xa = x;
    x = xa - f(xa)/Df(xa); n+=1;
  }
  return x;
}


double secante(double f(double), double a, double b,
               double eps, int &n, int & is){
  is = 0; double xaa = a, xa = b, x, Delta; n=0;
  Delta = ( f(xa) - f(xaa) ) / (xa - xaa);
  x = xa - f(xa) / Delta; n++;
  while( abs(x - xa) > eps){
    xaa = xa; xa = x;
    Delta = ( f(xa) - f(xaa) ) / (xa - xaa);
    x = xa - f(xa) / Delta; n++;
  }
  return x;
}
